//*****************************************************************************
// File: nvcmd.java
// Description: Nirva Java service command context
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: 
// ***************************************************************************************

package com.nirvasoft.nirva;


public class nvcmd
{
	private int iHandle = 0;
	
	public java.lang.String NvResult;

	// Native methods declaration
	private native int Int_GetCommandHandle();
	private native void Int_SetError(int NvHandle, java.lang.String ErrorClass, int ErrorCode, java.lang.String ErrorInfo);
	private native boolean Int_Command(int NvHandle, java.lang.String CommandString);
	private native java.lang.String Int_GetResult(int NvHandle);
	private native java.lang.String Int_GetSessionId(int NvHandle);
	private native java.lang.String Int_GetClass(int NvHandle);
	private native java.lang.String Int_GetCommand(int NvHandle);
	private native java.lang.String Int_GetInContainer(int NvHandle);
	private native java.lang.String Int_GetOutContainer(int NvHandle);
	private native java.lang.String Int_GetLanguage(int NvHandle);
	private native java.lang.String Int_GetMachineName(int NvHandle);
	private native java.lang.String Int_GetMachineUser(int NvHandle);
	private native java.lang.String Int_GetError(int NvHandle, java.lang.String InfoType);
	private native int Int_GetNumParameters(int NvHandle);
	private native java.lang.String Int_GetParameterName(int NvHandle, int Index);
	private native java.lang.String Int_GetSource(int NvHandle);
	private native boolean Int_IsCommand(int NvHandle, java.lang.String Class, java.lang.String Command, java.lang.String Source);
	private native boolean Int_ParameterExist(int NvHandle, java.lang.String ParameterName);
	private native java.lang.String Int_GetParameter(int NvHandle, java.lang.String ParameterName);
	private native void Int_AddHttpHeader(int NvHandle, java.lang.String HeaderName, java.lang.String HeaderValue);

	// constructor
	public nvcmd()
	{
		NvResult = "";
		iHandle = Int_GetCommandHandle();
	}
	
	public void SetError(java.lang.String ErrorClass, int ErrorCode, java.lang.String ErrorInfo){Int_SetError(iHandle, ErrorClass, ErrorCode, ErrorInfo);}
	public boolean Command(java.lang.String CommandString)
	{
		
		NvResult = "";
		boolean RetVal = Int_Command(iHandle, CommandString);
		if(RetVal)
			NvResult = Int_GetResult(iHandle);
		return RetVal;
	}
	public java.lang.String GetResult(){return Int_GetResult(iHandle);}
	public java.lang.String GetSessionId(){return Int_GetSessionId(iHandle);}
	public java.lang.String GetClass(){return Int_GetClass(iHandle);}
	public java.lang.String GetCommand(){return Int_GetCommand(iHandle);}
	public java.lang.String GetInContainer(){return Int_GetInContainer(iHandle);}
	public java.lang.String GetOutContainer(){return Int_GetOutContainer(iHandle);}
	public java.lang.String GetLanguage(){return Int_GetLanguage(iHandle);}
	public java.lang.String GetMachineName(){return Int_GetMachineName(iHandle);}
	public java.lang.String GetMachineUser(){return Int_GetMachineUser(iHandle);}
	public java.lang.String GetError(java.lang.String InfoType){return Int_GetError(iHandle, InfoType);}
	public int GetNumParameters(){return Int_GetNumParameters(iHandle);}
	public java.lang.String GetParameterName(int Index){return Int_GetParameterName(iHandle, Index);}
	public java.lang.String GetSource(){return Int_GetSource(iHandle);}
	public boolean IsCommand(java.lang.String Class, java.lang.String Command, java.lang.String Source){return Int_IsCommand(iHandle, Class, Command, Source);}
	public boolean ParameterExist(java.lang.String ParameterName){return Int_ParameterExist(iHandle, ParameterName);}
	public java.lang.String GetParameter(java.lang.String ParameterName){return Int_GetParameter(iHandle, ParameterName);}
	public void AddHttpHeader(java.lang.String HeaderName, java.lang.String HeaderValue){Int_AddHttpHeader(iHandle, HeaderName, HeaderValue);}

	// destructor
	protected void finalize() throws Throwable
	{
		iHandle = 0;
		super.finalize();
	}

}
