// ***************************************************************************************
// File: ejava.h
// Description: interface to java
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: 
// ***************************************************************************************

#ifndef _EJAVA_H
#define _EJAVA_H

#ifndef NVSTDCALL
#ifdef WIN32
#define NVSTDCALL __stdcall
#else
#define NVSTDCALL
#endif
#endif

#define NVJAVAVM void*

// java library entry points
typedef int (*JAVAINIT)(const char* NirvaDir, char* MinMemSize, char* MaxMemSize,const char* JavaHomeDir,const char* JvmPath,const char* JvmParam);
typedef void (*JAVAFREE)();
typedef int (*JAVARUNMETHOD)(const char* MethodName, void *pCommand);
typedef int (*JAVADETACHTHREAD)();
typedef int (*JAVAATTACHTHREAD)();


// Exported functions
extern "C"
{
int NvInitJava(const char* NirvaDir, char* MinMemSize, char* MaxMemSize, const char* JavaHomeDir, const char* JvmPath,const char* JvmParam);
void NvFreeJava();
int NvRunMethod(const char* MethodName, void *pCommand);
int NvDetachThread();
int NvAttachThread();
}


#endif //_EJAVA_H
