// ***************************************************************************************
// File: eperl.h
// Description: interface to perl
// Author: Pierre MARC
// Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Nirva Systems
//
// This file is part of Nirva Application Platform.
// 
// Nirva Application Platform is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Nirva Application Platform is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with Nirva Application Platform.  If not, see <http://www.gnu.org/licenses/>.
//
// ***************************************************************************************
// Comments: This file contains the declaration of the exported functions of
//           the nvperl library.
// ***************************************************************************************

#ifndef _EPERL_H
#define _EPERL_H

#ifndef NVSTDCALL
#ifdef WIN32
#define NVSTDCALL __stdcall
#else
#define NVSTDCALL
#endif
#endif
#ifdef WIN32
#ifdef _DEBUG
#include <crtdbg.h>
#endif
#endif

#define NVPERLINTERPRETOR void*

// perl library entry points
typedef NVPERLINTERPRETOR (*PERLGETINTERPRETOR)();
typedef void (*PERLFREEINTERPRETOR)(NVPERLINTERPRETOR Interpretor);
typedef int (*PERLRUNSCRIPT)(NVPERLINTERPRETOR Interpretor, const char* ScriptFileName, void *pCommand, int Debug);
typedef int (*PERLRUNSCRIPTMEMORY)(NVPERLINTERPRETOR Interpretor, const char* ScriptData, void *pCommand, int Debug);
typedef int (*INITPERLLIB)(const char* NirvaPath);
typedef void (*EXITPERLLIB)();



// Exported functions
extern "C"
{
NVPERLINTERPRETOR NvGetInterpretor();
void NvFreeInterpretor(NVPERLINTERPRETOR Interpretor);
int NvInterpretorRunScript(NVPERLINTERPRETOR Interpretor, const char* ScriptFileName, void *pCommand, int Debug);
int NvInterpretorRunScriptMemory(NVPERLINTERPRETOR Interpretor, const char* ScriptData, void *pCommand, int Debug);
int InitPerlLib(const char* NirvaPath);
void ExitPerlLib();
}


#endif //_EPERL_H
